searchNodes=[{"ref":"Crawly.html","title":"Crawly","type":"module","doc":"Crawly is a fast high-level web crawling &amp; scraping framework for Elixir."},{"ref":"Crawly.html#fetch/3","title":"Crawly.fetch/3","type":"function","doc":"Fetches a given url. This function is mainly used for the spiders development when you need to get individual pages and parse them"},{"ref":"Crawly.API.Router.html","title":"Crawly.API.Router","type":"module","doc":"Crawly HTTP API. Allows to schedule/stop/get_stats of all running spiders."},{"ref":"Crawly.API.Router.html#call/2","title":"Crawly.API.Router.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Crawly.API.Router.html#init/1","title":"Crawly.API.Router.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"Crawly.DataStorage.html","title":"Crawly.DataStorage","type":"module","doc":"Data Storage, is a module responsible for storing crawled items. On the high level it&#39;s possible to represent the architecture of items storage this way: ┌──────────────────┐ │ │ ┌------------------┐ │ DataStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │ DataStorageWorker1 │ │ DataStorageWorker2 │ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘"},{"ref":"Crawly.DataStorage.html#child_spec/1","title":"Crawly.DataStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.DataStorage.html#init/1","title":"Crawly.DataStorage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.DataStorage.html#start_link/1","title":"Crawly.DataStorage.start_link/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#start_worker/1","title":"Crawly.DataStorage.start_worker/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#stats/1","title":"Crawly.DataStorage.stats/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.html#store/2","title":"Crawly.DataStorage.store/2","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html","title":"Crawly.DataStorage.Worker","type":"module","doc":"A worker process which stores items for individual spiders. All items are pre-processed by item_pipelines. All pipelines are using the state of this process for their internal needs (persistancy). For example, it might be useful to include: 1) DuplicatesFilter pipeline (it filters out already seen items) 2) JSONEncoder pipeline (it converts items to JSON)"},{"ref":"Crawly.DataStorage.Worker.html#child_spec/1","title":"Crawly.DataStorage.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.DataStorage.Worker.html#init/1","title":"Crawly.DataStorage.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.DataStorage.Worker.html#start_link/1","title":"Crawly.DataStorage.Worker.start_link/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html#stats/1","title":"Crawly.DataStorage.Worker.stats/1","type":"function","doc":""},{"ref":"Crawly.DataStorage.Worker.html#store/2","title":"Crawly.DataStorage.Worker.store/2","type":"function","doc":""},{"ref":"Crawly.Engine.html","title":"Crawly.Engine","type":"module","doc":"Crawly Engine - process responsible for starting and stopping spiders. Stores all currently running spiders."},{"ref":"Crawly.Engine.html#child_spec/1","title":"Crawly.Engine.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Engine.html#init/1","title":"Crawly.Engine.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Engine.html#running_spiders/0","title":"Crawly.Engine.running_spiders/0","type":"function","doc":""},{"ref":"Crawly.Engine.html#start_link/0","title":"Crawly.Engine.start_link/0","type":"function","doc":""},{"ref":"Crawly.Engine.html#start_spider/1","title":"Crawly.Engine.start_spider/1","type":"function","doc":""},{"ref":"Crawly.Engine.html#stop_spider/1","title":"Crawly.Engine.stop_spider/1","type":"function","doc":""},{"ref":"Crawly.EngineSup.html","title":"Crawly.EngineSup","type":"module","doc":"Engine supervisor responsible for spider subtrees"},{"ref":"Crawly.EngineSup.html#child_spec/1","title":"Crawly.EngineSup.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.EngineSup.html#init/1","title":"Crawly.EngineSup.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke DynamicSupervisor.init/1 at the end of their init callback to return the proper supervision flags. Callback implementation for DynamicSupervisor.init/1."},{"ref":"Crawly.EngineSup.html#start_link/0","title":"Crawly.EngineSup.start_link/0","type":"function","doc":""},{"ref":"Crawly.EngineSup.html#start_spider/1","title":"Crawly.EngineSup.start_spider/1","type":"function","doc":""},{"ref":"Crawly.EngineSup.html#stop_spider/1","title":"Crawly.EngineSup.stop_spider/1","type":"function","doc":""},{"ref":"Crawly.Manager.html","title":"Crawly.Manager","type":"module","doc":"Crawler manager module This module is responsible for spawning all processes related to a given Crawler. The manager spawns the following processes tree. ┌────────────────┐ ┌───────────────────┐ │ Crawly.Manager ├────────&gt; Crawly.ManagerSup │ └────────────────┘ └─────────┬─────────┘ │ | │ | ┌──────────────────────────┤ │ │ │ │ ┌────────▼───────┐ ┌─────────▼───────┐ │ Worker1 │ │ Worker2 │ └────────┬───────┘ └────────┬────────┘ │ │ │ │ │ │ │ │ ┌────────▼─────────┐ ┌──────────▼───────────┐ │Crawly.DataStorage│ │Crawly.RequestsStorage│ └──────────────────┘ └──────────────────────┘"},{"ref":"Crawly.Manager.html#child_spec/1","title":"Crawly.Manager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Manager.html#init/1","title":"Crawly.Manager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Manager.html#start_link/1","title":"Crawly.Manager.start_link/1","type":"function","doc":""},{"ref":"Crawly.ManagerSup.html","title":"Crawly.ManagerSup","type":"module","doc":"A supervisor module used to spawn Crawler trees"},{"ref":"Crawly.ManagerSup.html#child_spec/1","title":"Crawly.ManagerSup.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.ManagerSup.html#start_link/1","title":"Crawly.ManagerSup.start_link/1","type":"function","doc":""},{"ref":"Crawly.Middlewares.DomainFilter.html","title":"Crawly.Middlewares.DomainFilter","type":"module","doc":"Filters out requests which are going outside of the crawled domain"},{"ref":"Crawly.Middlewares.DomainFilter.html#run/2","title":"Crawly.Middlewares.DomainFilter.run/2","type":"function","doc":"Callback implementation for Crawly.Pipeline.run/2."},{"ref":"Crawly.Middlewares.RobotsTxt.html","title":"Crawly.Middlewares.RobotsTxt","type":"module","doc":"Obey robots.txt A robots.txt file tells search engine crawlers which pages or files the crawler can or can&#39;t request from your site. This is used mainly to avoid overloading a site with requests! Please NOTE: The first rule of web crawling is you do not harm the website. The second rule of web crawling is you do NOT harm the website"},{"ref":"Crawly.Middlewares.RobotsTxt.html#run/2","title":"Crawly.Middlewares.RobotsTxt.run/2","type":"function","doc":"Callback implementation for Crawly.Pipeline.run/2."},{"ref":"Crawly.Middlewares.UniqueRequest.html","title":"Crawly.Middlewares.UniqueRequest","type":"module","doc":"Avoid scheduling requests for the same pages."},{"ref":"Crawly.Middlewares.UniqueRequest.html#run/2","title":"Crawly.Middlewares.UniqueRequest.run/2","type":"function","doc":""},{"ref":"Crawly.Middlewares.UserAgent.html","title":"Crawly.Middlewares.UserAgent","type":"module","doc":"Set/Rotate user agents for crawling. The user agents are read from :crawly, :user_agents sessions. The default value for the user agent is: Crawly Bot 1.0"},{"ref":"Crawly.Middlewares.UserAgent.html#run/2","title":"Crawly.Middlewares.UserAgent.run/2","type":"function","doc":""},{"ref":"Crawly.ParsedItem.html","title":"Crawly.ParsedItem","type":"module","doc":"Defines the structure of spider&#39;s result"},{"ref":"Crawly.ParsedItem.html#t:item/0","title":"Crawly.ParsedItem.item/0","type":"type","doc":""},{"ref":"Crawly.ParsedItem.html#t:t/0","title":"Crawly.ParsedItem.t/0","type":"type","doc":""},{"ref":"Crawly.Pipeline.html","title":"Crawly.Pipeline","type":"behaviour","doc":"A behavior module for implementing a pipeline module A pipeline is a module which takes a given item, and executes a run callback on a given item. A state variable is used to share common information accros multiple items."},{"ref":"Crawly.Pipeline.html#c:run/2","title":"Crawly.Pipeline.run/2","type":"callback","doc":""},{"ref":"Crawly.Pipelines.CSVEncoder.html","title":"Crawly.Pipelines.CSVEncoder","type":"module","doc":"Encodes a given item (map) into CSV"},{"ref":"Crawly.Pipelines.DuplicatesFilter.html","title":"Crawly.Pipelines.DuplicatesFilter","type":"module","doc":"Filters out duplicated items (helps to avoid storing duplicates) This pipeline uses Crawly.DataStorageWorker process state in order to store ids of already seen items. For now they are stored only in memory. The field responsible for identifying duplicates is specified using :crawly.item_id setting."},{"ref":"Crawly.Pipelines.JSONEncoder.html","title":"Crawly.Pipelines.JSONEncoder","type":"module","doc":"Encodes a given item (map) into JSON"},{"ref":"Crawly.Pipelines.Validate.html","title":"Crawly.Pipelines.Validate","type":"module","doc":"Ensure that scraped item contains all fields defined in config: item."},{"ref":"Crawly.Request.html","title":"Crawly.Request","type":"module","doc":"Request wrapper Defines Crawly request structure."},{"ref":"Crawly.Request.html#t:header/0","title":"Crawly.Request.header/0","type":"type","doc":""},{"ref":"Crawly.Request.html#t:option/0","title":"Crawly.Request.option/0","type":"type","doc":""},{"ref":"Crawly.Request.html#t:t/0","title":"Crawly.Request.t/0","type":"type","doc":""},{"ref":"Crawly.RequestsStorage.html","title":"Crawly.RequestsStorage","type":"module","doc":"Request storage, a module responsible for storing urls for crawling ┌──────────────────┐ │ │ ┌------------------┐ │ RequestsStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │ ┌───────────▼──────────┐ ┌───────────▼──────────┐ │RequestsStorageWorker1│ │RequestsStorageWorker2│ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘ All requests are going through one RequestsStorage process, which quickly finds the actual worker, which finally stores the request afterwords."},{"ref":"Crawly.RequestsStorage.html#child_spec/1","title":"Crawly.RequestsStorage.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.RequestsStorage.html#init/1","title":"Crawly.RequestsStorage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.RequestsStorage.html#pop/1","title":"Crawly.RequestsStorage.pop/1","type":"function","doc":"Pop a request out of requests storage"},{"ref":"Crawly.RequestsStorage.html#start_link/1","title":"Crawly.RequestsStorage.start_link/1","type":"function","doc":""},{"ref":"Crawly.RequestsStorage.html#start_worker/1","title":"Crawly.RequestsStorage.start_worker/1","type":"function","doc":"Starts a worker for a given spider"},{"ref":"Crawly.RequestsStorage.html#stats/1","title":"Crawly.RequestsStorage.stats/1","type":"function","doc":"Get statistics from the requests storage"},{"ref":"Crawly.RequestsStorage.html#store/2","title":"Crawly.RequestsStorage.store/2","type":"function","doc":"Store request in related child worker"},{"ref":"Crawly.RequestsStorage.Worker.html","title":"Crawly.RequestsStorage.Worker","type":"module","doc":"Requests Storage, is a module responsible for storing requests for a given spider. Automatically filters out already seen requests (uses fingerprints approach to detect already visited pages). Pipes all requests through a list of middlewares, which do pre-processing of all requests before storing them"},{"ref":"Crawly.RequestsStorage.Worker.html#child_spec/1","title":"Crawly.RequestsStorage.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.RequestsStorage.Worker.html#init/1","title":"Crawly.RequestsStorage.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.RequestsStorage.Worker.html#pop/1","title":"Crawly.RequestsStorage.Worker.pop/1","type":"function","doc":"Pop a request out of requests storage"},{"ref":"Crawly.RequestsStorage.Worker.html#start_link/1","title":"Crawly.RequestsStorage.Worker.start_link/1","type":"function","doc":""},{"ref":"Crawly.RequestsStorage.Worker.html#stats/1","title":"Crawly.RequestsStorage.Worker.stats/1","type":"function","doc":"Get statistics from the requests storage"},{"ref":"Crawly.RequestsStorage.Worker.html#store/2","title":"Crawly.RequestsStorage.Worker.store/2","type":"function","doc":"Store individual request request"},{"ref":"Crawly.Spider.html","title":"Crawly.Spider","type":"behaviour","doc":"A behavior module for implementing a Crawly Spider A Spider is a module which is responsible for defining: init/0 function, which must return a keyword list with start_urls list base_url/0 function responsible for filtering out requests not related to a given website parse_item/1 function which is responsible for parsing the downloaded request and converting it into items which can be stored and new requests which can be scheduled"},{"ref":"Crawly.Spider.html#c:base_url/0","title":"Crawly.Spider.base_url/0","type":"callback","doc":""},{"ref":"Crawly.Spider.html#c:init/0","title":"Crawly.Spider.init/0","type":"callback","doc":""},{"ref":"Crawly.Spider.html#c:parse_item/1","title":"Crawly.Spider.parse_item/1","type":"callback","doc":""},{"ref":"Crawly.Utils.html","title":"Crawly.Utils","type":"module","doc":"Utility functions for Crawly"},{"ref":"Crawly.Utils.html#pipe/3","title":"Crawly.Utils.pipe/3","type":"function","doc":"Pipeline/Middleware helper Executes a given list of pipelines on the given item, mimics filtermap behavior (but probably in a more complex way). Takes an item and state and passes it through a list of modules which implements a pipeline behavior, executing the pipeline&#39;s run. The pipe function must return boolean (false) or updated item. In case if false is returned the item is not being processed by all descendant pipelines, and dropped. In case if a given pipeline crashes for the given item, it&#39;s result are being ignored, and the item is being processed by all other descendant pipelines. The state variable is used to persist the information accross multiple items."},{"ref":"Crawly.Utils.html#request_from_url/1","title":"Crawly.Utils.request_from_url/1","type":"function","doc":"A helper function which returns a Request structure for the given URL"},{"ref":"Crawly.Worker.html","title":"Crawly.Worker","type":"module","doc":"A worker process responsible for the actual work (fetching requests, processing responces)"},{"ref":"Crawly.Worker.html#child_spec/1","title":"Crawly.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crawly.Worker.html#init/1","title":"Crawly.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. args is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Crawly.Worker.html#start_link/1","title":"Crawly.Worker.start_link/1","type":"function","doc":""}]